Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumEnumerator.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumEnumerator.cpp	(revision 48306)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumEnumerator.cpp	(revision 48307)
@@ -100,5 +100,5 @@
     /* Get medium ID: */
     QString strMediumID = medium.id();
-    LogRel(("UIMediumEnumerator: Medium with ID={%s} created.\n", strMediumID.toAscii().constData()));
+    LogRelFlow(("UIMediumEnumerator: Medium with ID={%s} created.\n", strMediumID.toAscii().constData()));
 
     /* Make sure medium doesn't exists already: */
@@ -116,5 +116,5 @@
     /* Get medium ID: */
     QString strMediumID = medium.id();
-    LogRel(("UIMediumEnumerator: Medium with ID={%s} updated.\n", strMediumID.toAscii().constData()));
+    LogRelFlow(("UIMediumEnumerator: Medium with ID={%s} updated.\n", strMediumID.toAscii().constData()));
 
     /* Make sure medium still exists: */
@@ -130,5 +130,5 @@
 void UIMediumEnumerator::deleteMedium(const QString &strMediumID)
 {
-    LogRel(("UIMediumEnumerator: Medium with ID={%s} removed.\n", strMediumID.toAscii().constData()));
+    LogRelFlow(("UIMediumEnumerator: Medium with ID={%s} removed.\n", strMediumID.toAscii().constData()));
 
     /* Make sure medium still exists: */
@@ -159,5 +159,5 @@
 
     /* Notify listener: */
-    LogRel(("UIMediumEnumerator: Medium-enumeration started...\n"));
+    LogRelFlow(("UIMediumEnumerator: Medium-enumeration started...\n"));
     m_fMediumEnumerationInProgress = true;
     emit sigMediumEnumerationStarted();
@@ -171,5 +171,5 @@
 void UIMediumEnumerator::sltHandleMachineUpdate(QString strMachineID)
 {
-    LogRel(("Machine event received, ID = %s\n", strMachineID.toAscii().constData()));
+    LogRelFlow(("UIMediumEnumerator: Machine event received, ID = %s\n", strMachineID.toAscii().constData()));
 
     /* Compose a map of previous usage: */
@@ -182,5 +182,5 @@
             oldUsage << strMediumID;
     }
-    LogRel(("Old usage: %s\n", oldUsage.join(", ").toAscii().constData()));
+    LogRelFlow(("UIMediumEnumerator:  Old usage: %s\n", oldUsage.isEmpty() ? "<empty>" : oldUsage.join(", ").toAscii().constData()));
 
     /* Compose a map of current usage: */
@@ -201,5 +201,5 @@
         }
     }
-    LogRel(("New usage: %s\n", newUsage.join(", ").toAscii().constData()));
+    LogRelFlow(("UIMediumEnumerator:  New usage: %s\n", newUsage.isEmpty() ? "<empty>" : newUsage.join(", ").toAscii().constData()));
 
     /* Manipulations over the sets: */
@@ -210,6 +210,8 @@
     QStringList excludedList = excludedSet.toList();
     QStringList includedList = includedSet.toList();
-    LogRel(("Excluded items of machine usage: %s\n", excludedList.join(", ").toAscii().constData()));
-    LogRel(("Included items of machine usage: %s\n", includedList.join(", ").toAscii().constData()));
+    if (!excludedList.isEmpty())
+        LogRelFlow(("UIMediumEnumerator:  Items excluded from machine usage: %s\n", excludedList.join(", ").toAscii().constData()));
+    if (!includedList.isEmpty())
+        LogRelFlow(("UIMediumEnumerator:  Items included into machine usage: %s\n", includedList.join(", ").toAscii().constData()));
 
     /* For each of excluded items: */
@@ -244,5 +246,5 @@
     }
 
-    LogRel(("Machine event processed, ID = %s\n", strMachineID.toAscii().constData()));
+    LogRelFlow(("UIMediumEnumerator: Machine event processed, ID = %s\n", strMachineID.toAscii().constData()));
 }
 
@@ -256,5 +258,5 @@
     UIMedium medium = pTask->data().value<UIMedium>();
     QString strMediumID = medium.id();
-    LogRel(("UIMediumEnumerator: Medium with ID={%s} enumerated.\n", strMediumID.toAscii().constData()));
+    LogRelFlow(("UIMediumEnumerator: Medium with ID={%s} enumerated.\n", strMediumID.toAscii().constData()));
 
     /* Delete task: */
@@ -275,5 +277,5 @@
     {
         /* Notify listener: */
-        LogRel(("UIMediumEnumerator: Medium-enumeration finished!\n"));
+        LogRelFlow(("UIMediumEnumerator: Medium-enumeration finished!\n"));
         m_fMediumEnumerationInProgress = false;
         emit sigMediumEnumerationFinished();